;====================================================================
UseMb=1	; put 0 if you don't have the library (http://www.masm32.com/board/index.php?topic=12460)
if UseMb
	include \masm32\MasmBasic\MasmBasic.inc
	MbStrCmp	PROTO: DWORD, :DWORD, :DWORD
else
	include \masm32\include\masm32rt.inc
endif
    .686
    include \masm32\macros\timers.asm
;====================================================================
CmpiJJ	PROTO: DWORD, :DWORD
    .data
    align 16
        str1 db "MY OTHER PROTHER", 0	; test early mismatches
        ;str1 db "my other brother darryl", 0
        str2 db 4 dup("my other brother darryl"), 0
        str3 db 128 dup("my other brother darryl"), 0
    align 16
        str1b db "my other brother darryl", 0
        str2b db 4 dup("my other brother darryl"), 0
        str3b db 128 dup("my other brother darryl"), 0
    align 16
    if 1
	    sLow db "ths is  tst with ", 0
	    sUpp db "THS IS  TST WITH ", 0
    else
	    sLow db "this is a test", 0
	    sUpp db "THIS IS A TEST", 0
    endif

.data
      szCmpi_tbl \
      db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
      db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
      db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
      db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
      db  64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95
      db  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127	; charLowerBuff
      db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
      db 144,145,146,147,148,149,150,151,152,153,154,155,156,156,158,159
      db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,173,175
      db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
      db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
      db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
      db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
      db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255

    .code
;====================================================================
start:
;====================================================================
	push 1
	call ShowCpu	; print brand string and SSE level
	
LC_ALL equ 0
invoke crt_setlocale, LC_ALL, chr$("English")

    invoke Sleep, 100
    MyLoops = 5000000/10

    FOR string,<str1,str2,str3>
	strb CATSTR <string>, <b>
	MyLoops=MyLoops/5
	print str$(SIZEOF string)," bytes",13,10

if UseMb
        counter_begin MyLoops, HIGH_PRIORITY_CLASS
	invoke MbStrCmp, offset string, offset strb, 1
	mov esi, eax
	mov edi, edx
        counter_end
	print str$(eax)," cycles, MasmBasic StringsDiffer(), mismatch: "
	print str$(esi)
	.if esi
	        print " at "
		print str$(edi), 13,10
	.else
		print chr$(13, 10)
	.endif
endif

        counter_begin MyLoops, HIGH_PRIORITY_CLASS
            invoke CmpiJJ, ADDR string, ADDR strb
	mov esi, eax
        counter_end
        print str$(eax)," cycles, CmpiJJ, mismatch: "
        print str$(esi),13,10

        counter_begin MyLoops, HIGH_PRIORITY_CLASS
            invoke szCmpi, ADDR string, ADDR strb, SIZEOF string
	mov esi, eax
        counter_end
        print str$(eax)," cycles, szCmpi, mismatch: "
        print str$(esi),13,10

        counter_begin MyLoops, HIGH_PRIORITY_CLASS
            invoke Cmpi, ADDR string, ADDR strb
	mov esi, eax
        counter_end
        print str$(eax)," cycles, Cmpi, mismatch: "
        print str$(esi),13,10

        counter_begin MyLoops/10, HIGH_PRIORITY_CLASS
            invoke crt__stricmp, ADDR string, ADDR strb
	mov esi, eax
        counter_end
        print str$(eax)," cycles, crt__stricmp, mismatch: "
        print str$(esi),13,10, 10

    ENDM

print "Correctness (expected: equal):", 13, 10
if UseMb
	.if StringsDiffer(offset sLow, offset sUpp, 1)
		print "non-equal"
	.else
		print "equal"
	.endif
	print " for MasmBasic", 13, 10
endif
	invoke CmpiJJ, ADDR sLow, ADDR sUpp
	.if eax
		print "non-equal"
	.else
		print "equal"
	.endif
	print " for CmpiJJ", 13, 10
	invoke szCmpi, ADDR sLow, ADDR sUpp, SIZEOF sLow
	.if eax
		print "non-equal"
	.else
		print "equal"
	.endif
	print " for szCmpi", 13, 10
	invoke Cmpi, ADDR sLow, ADDR sUpp
	.if eax
		print "non-equal"
	.else
		print "equal"
	.endif
	print " for Cmpi", 13, 10
	invoke crt__stricmp, ADDR sLow, ADDR sUpp, SIZEOF sLow
	.if eax
		print "non-equal"
	.else
		print "equal"
	.endif
	print " for crt__stricmp", 13, 10, 10
if UseMb
	print "Code size:", 13, 10
	CodeSize Cmpi
	CodeSize CmpiJJ
endif
    inkey chr$(13, 10, "Press any key to exit...")
    exit

;====================================================================
; select the two lines and press Control X to cut
; code for printing brand string and SSE level
	push 1
	call ShowCpu	; print brand string and SSE level
ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp


OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

szCmpi proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi

    mov esi, [esp+4+12]
    mov edi, [esp+8+12]
    sub eax, eax                    ; zero eax as index

  align 4
  @@:
    movzx edx, BYTE PTR [esi+eax]
    movzx ebx, BYTE PTR [edi+eax]
    movzx ecx, BYTE PTR [edx+szCmpi_tbl]
    add eax, 1
    cmp cl, [ebx+szCmpi_tbl]
    jne quit
    cmp eax, [esp+12+12]
    jb @b

    sub eax, eax

  quit:
    pop edi
    pop esi
    pop ebx

    ret 12

szCmpi endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16
Cmpi_s:
      Cmpi_tbl \
      db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
      db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
      db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
      db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
      db  64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95
      db  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
      db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
      db 144,145,146,147,148,149,150,151,152,153,154,155,156,156,158,159
      db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,173,175
      db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
      db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
      db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
      db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
      db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
Cmpi proc src:DWORD,dst:DWORD

    push ebx
    push esi
    push edi

    mov esi, [esp+16]               ; src
    mov edi, [esp+20]               ; dst
    sub eax, eax                    ; zero eax as index

  align 4
  @@:
    movzx edx, BYTE PTR [esi+eax]
    movzx ebx, BYTE PTR [edi+eax]
    movzx ecx, BYTE PTR [edx+Cmpi_tbl]
    add eax, 1
    cmp cl, [ebx+Cmpi_tbl]
    jne quit                        ; exit on 1st mismatch with
    test cl, cl                     ; non zero value in EAX
    jnz @B

    sub eax, eax                    ; set EAX to ZERO on match

  quit:
    pop edi
    pop esi
    pop ebx

    ret 8

Cmpi endp
Cmpi_endp:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 


; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
CmpiJJ_s:
CmpiJJ proc src:DWORD,dst:DWORD
    .data?
Cmpi_tbl2 dd 256/4 dup(?)
    .code
	push ecx	; MasmBasic preserves ecx
	push ebx
	push esi
	push edi
@@:	xor eax, eax
	mov ebx, offset Cmpi_tbl2
	cmp [ebx], eax
	.if Zero?
		enter 512, 0	; speed does not matter here -
		mov edi, ebx	; the table will be loaded once
		mov esi, esp
		.Repeat
				mov [esi], al					; create two copies
				mov [esi+256], al			; of ASCII 0...255
				inc esi
				stosb
				inc eax
		.Until ah
		xchg edi, eax	; edi=256, numbytes
		mov esi, esp
		invoke CharLowerBuff, esi, edi
		add esi, edi
		invoke CharUpperBuff, esi, edi
		.Repeat
				lodsb							; esi is upper$
				.if [ebx]!=al
					mov [ebx], al			; change original table
				.else
					mov al, [esi-257]		; lower
					.if [ebx]!=al				; cmpxchg would be nice but works the wrong way...
						mov [ebx], al		; change original table
					.endif
				.endif
				inc ebx
				dec edi						; edi=256...0
		.Until Zero?
;		lea eax, [ebx-256+32]
;		deb 1, "Mist", $eax
		leave
		jmp @B
	.endif
	mov esi, [esp+20]	; src
	mov edi, [esp+24]	; dst
	dec edi	; correct for early inc eax
@@:	movzx ecx, byte ptr [esi+eax]	; edx=byte of src
	inc eax
	jecxz @F	; nullbyte, end of string; test ecx, ecx/je @F is not faster
	cmp cl, [edi+eax]
	je @B
	; movzx edx, byte ptr [edi+eax]	; ecx=byte of dest
	mov dl, [edi+eax]	; ecx=byte of dest
	cmp dl, [ebx+ecx]	; cl=byte of src, 2nd chance
	je @B
@@:	cmp cl, [edi+eax]	; cl=byte of dest
	jne @F
	xor eax, eax	; set EAX to ZERO on match
@@:	pop edi
	pop esi
	pop ebx
	pop ecx
	ret 8
CmpiJJ endp
CmpiJJ_endp:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

end start
OPT_Tmp2Asm	1
